"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
const plugin_proposal_async_do_expressions_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-async-do-expressions"));
const plugin_proposal_class_properties_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-class-properties"));
const plugin_proposal_class_static_block_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-class-static-block"));
const plugin_proposal_do_expressions_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-do-expressions"));
const plugin_proposal_function_bind_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-function-bind"));
const plugin_proposal_function_sent_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-function-sent"));
const plugin_proposal_json_strings_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-json-strings"));
const plugin_proposal_partial_application_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-partial-application"));
const plugin_proposal_pipeline_operator_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-pipeline-operator"));
const plugin_proposal_private_property_in_object_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-private-property-in-object"));
const plugin_proposal_record_and_tuple_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-record-and-tuple"));
const plugin_proposal_throw_expressions_1 = tslib_1.__importDefault(require("@babel/plugin-proposal-throw-expressions"));
const plugin_syntax_decorators_1 = tslib_1.__importDefault(require("@babel/plugin-syntax-decorators"));
const plugin_syntax_typescript_1 = tslib_1.__importDefault(require("@babel/plugin-syntax-typescript"));
const v8intrinsic_1 = tslib_1.__importDefault(require("./v8intrinsic"));
const utils_1 = require("./utils");
exports.default = helper_plugin_utils_1.declare((api, { classLoose, decoratorsBeforeExport, decoratorsLegacy = true, isTSX, pipelineOperator = 'minimal', recordTuplePolyfill = utils_1.IS_RECORD_TUPLE_SUPPORTED, recordTupleSyntaxType = 'hash', }) => {
    api.assertVersion(7);
    return {
        plugins: [
            [
                plugin_syntax_decorators_1.default,
                {
                    decoratorsBeforeExport,
                    legacy: decoratorsLegacy,
                },
            ],
            [
                plugin_syntax_typescript_1.default,
                {
                    isTSX,
                },
            ],
            v8intrinsic_1.default,
            plugin_proposal_async_do_expressions_1.default,
            [
                plugin_proposal_class_static_block_1.default,
                {
                    loose: classLoose,
                },
            ],
            [
                plugin_proposal_class_properties_1.default,
                {
                    loose: classLoose,
                },
            ],
            plugin_proposal_do_expressions_1.default,
            plugin_proposal_function_bind_1.default,
            plugin_proposal_function_sent_1.default,
            plugin_proposal_json_strings_1.default,
            plugin_proposal_partial_application_1.default,
            [
                plugin_proposal_pipeline_operator_1.default,
                {
                    proposal: pipelineOperator,
                },
            ],
            [
                plugin_proposal_private_property_in_object_1.default,
                {
                    loose: classLoose,
                },
            ],
            recordTuplePolyfill && [
                plugin_proposal_record_and_tuple_1.default,
                {
                    importPolyfill: !!recordTuplePolyfill,
                    polyfillModuleName: typeof recordTuplePolyfill === 'string'
                        ? recordTuplePolyfill
                        : undefined,
                    syntaxType: recordTupleSyntaxType,
                },
            ],
            plugin_proposal_throw_expressions_1.default,
        ].filter(Boolean),
        // no need to override if it has been enabled
        overrides: isTSX
            ? undefined
            : [
                {
                    test: /\.[jt]sx$/,
                    plugins: [
                        [
                            plugin_syntax_typescript_1.default,
                            {
                                isTSX: true,
                            },
                        ],
                    ],
                },
            ],
    };
});
//# sourceMappingURL=index.js.map